<?php
include "simple_html_dom.php";

global $sdgc_db_version, $options;
$sdgc_db_version = '1.0';

$installed_ver = get_option( "sdgc_db_version" );
if ( $installed_ver != $sdgc_db_version ) {

}

class GoogleCalendars {
	public $default_fields = array(
		
	);
	
	function __construct() {
		add_action( 'init', array( $this, 'sdgc_init') );
	}
	
	function sdgc_init() {
		$this->sdgc_register_post_type();
        add_action( 'wp_enqueue_scripts', array($this, 'sdgc_include_custom_jquery'));
        add_action( 'admin_enqueue_scripts', array($this, 'sdgc_include_custom_jquery'));
		add_action( 'add_meta_boxes', array($this, 'sdgc_meta_box_main_data'));
		add_action( 'save_post', array($this, 'sdgc_save_meta_box_data'));
		add_action( 'admin_head', array($this, 'sdgc_AdminHeadSectionHook'));
		add_action( 'wp_head', array($this, 'sdgc_frontendHeadHook'));
		//$this->sdgc_filters();
		/*
		add_action( 'rest_api_init', function () {
		    register_rest_route( 'rest-routes/v2', '/(?P<id>[a-zA-Z-_0-9]+)', array(
			    'methods' => WP_REST_Server::READABLE,
			    'callback' => array( $this, 'custom_get_route' )
			) );
		} );
		*/
		add_action( 'admin_menu', array( $this, 'sdgc_admin_menu' ) );
		add_action( 'rest_api_init', array('SDGoogleCalendar_Custom_Route', 'init'));
		add_shortcode( 'sd_show_calendar', array( $this, 'showcalendartag_func' ));
		add_action( 'sdgc_save_fields', array($this, 'calendar_save_output'), 10, 2 );
		if(empty(get_option('sdgc_cron_option'))){ add_option('sdgc_cron_option', 'daily'); }
	}

	// include latest jQuery
	function sdgc_include_custom_jquery() {
		//wp_deregister_script('jquery');
        //wp_enqueue_script( 'my-great-script', plugin_dir_url( __FILE__ ) . '/js/my-great-script.js', array( 'jquery' ), '1.0.0', true );
		wp_enqueue_script('jquery', 'https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js', array('jquery'), '3.1.1', true);
	}
	function sdgc_frontendHeadHook(){
	  $output = "<link rel='stylesheet' href='".SDGC_URL."/css/sd-google-calendar.css'></link>";
	  echo $output;
	}
	function sdgc_AdminHeadSectionHook() {
	  $output = "<script src='".SDGC_URL."/js/jscolor.min.js' type='text/javascript'></script>";
	  echo $output;
	}
	function sdgc_admin_menu() {
		add_menu_page('Google Calendars', 'Google Calendars', 'manage_options', 'edit.php?post_type=sd-google-calendars', '',  'dashicons-share');
		add_submenu_page( 'edit.php?post_type=sd-google-calendars', 'Calendar Settings', 'Settings', 'manage_options', 'sd-calendar-settings', array($this, 'sdgc_calendarSettings'));
        add_submenu_page( 'edit.php?post_type=sd-google-calendars', 'Custom Events', 'Custom Events', 'manage_options', 'sd-calendar-approvals', array($this, 'sdgc_calendarApprovals'));
		//add_submenu_page( 'edit.php?post_type=sd-google-calendars', 'Calendars', 'My Google Calendars', 'manage_options', 'edit.php?post_type=sd-google-calendars');
		//add_submenu_page( 'edit.php?post_type=rest-routes', 'Settings', 'Settings', 'manage_options', 'wprr-settings', 'wprr_admin_menu_settings' );
		//add_submenu_page( 'edit.php?post_type=rest-routes', 'Help', 'Help', 'manage_options', 'wprr-help', 'wprr_admin_menu_help' );
	}

	function sdgc_calendarSettings(){
		if(!empty($_POST['sdgc_cron_option'])){
			update_option('sdgc_cron_option', $_POST['sdgc_cron_option']);
			$this->sdgc_setupCron();
		}
		if(!empty($_POST['sdgc_googlekey_option'])){
		    update_option('sdgc_googlekey_option', $_POST['sdgc_googlekey_option']);
        }
		$cronCycle = get_option('sdgc_cron_option');
		//print_r($options);
		//echo unserialize()
		//$postedCronCycle = unserialize( get_post_meta($post->ID, '_sdgc_calendar_urls', true) );


		echo '<div class="sd-calendar-combined-div wrap" style="margin:10px;">';
		echo '<form method="post">';
		wp_nonce_field( 'sdgc_save_meta_box_data', 'sdgc_meta_box_nonce' );
		echo '<h1>Settings for the Google Calendar combiner.</h1>'.
				 '<table class="form-table sdgc-calendar-fields">'.
				 '   <tbody>'.
				 '       <tr>'.
				 '       	<th scope="row">Update Rate</th>'.
				 '        <td><select name="sdgc_cron_option"><option value="hourly" '.($cronCycle == "hourly" ? 'selected' : '').'>Hourly</option>'.
				 '						<option value="twicedaily" '.($cronCycle == "twicedaily" ? 'selected' : '').'>Twice Daily</option>'.
		     '            <option value="daily" '.($cronCycle == "daily" ? 'selected' : '').'>Daily</option></select></td>';
		echo '</tr>'.
             '<tr><th scope="row">Google Server Key<br/><i>Must have Google Maps API enabled</i></th><td>'.
             '<input type="text" name="sdgc_googlekey_option" placeholder="Server API Key" value="'.(!empty(get_option('sdgc_googlekey_option')) ? get_option('sdgc_googlekey_option') : '').'"/></td></tr>'.
            '</tbody></table>';
		submit_button();
		echo "</form>";
		echo '</div>';
	}

	function sdgc_calendarApprovals(){
      global $wpdb;
      $table_name = $wpdb->prefix . "sdgc_events";
      $filterStatus = isset($_POST['sdgc-approval-status']) ? $_POST['sdgc-approval-status'] : "1";
      if(isset($_POST['selectedEvents']) && isset($_POST["submit_action"])){
          if(strcmp($_POST["submit_action"], "action") == 0) {
              $approve = strcmp("approve", $_POST["sdgc-approval-option"]) == 0;
	          $spam = strcmp("spam", $_POST["sdgc-approval-option"]) == 0;
	          $delete = strcmp("delete", $_POST["sdgc-approval-option"]) == 0;
	          foreach ( $_POST['selectedEvents'] as $e ) {
	              if(!$delete) {
                      $wpdb->update( $table_name,
                          array( 'customentry' => $approve ? "2" : "-1" ),
                          array( 'ID' => $e ),
                          array( '%d' ), //set value
                          array( '%d' ) //where
                      );
                  }else{
                      $wpdb->delete( $table_name, array( 'ID' => $e ));
                  }
	          }
          }
      }
      $filter = "customentry = 1 or customentry = 2";
      if(isset($_POST['submit_action']) && strcmp($_POST["submit_action"], "filter") == 0){
          $filter = "customentry = ".$filterStatus;
      }
      $page = isset($_POST['page']) ? $_POST['page'] : 1;
      $pageRecords = 20;
      wp_register_script('prefix_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js');
      wp_enqueue_script('prefix_bootstrap');
      wp_register_style('prefix_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css');
      wp_enqueue_style('prefix_bootstrap');
      $now        = current_time( 'mysql' );
      $results = $wpdb->get_results("SELECT count(*) FROM {$table_name} where {$filter}", ARRAY_N );
      $recordcount = $results[0][0];
      //$results = $wpdb->get_results( $wpdb->prepare( "SELECT count(*) FROM {$table_name} where eventid = %s", $evt["eventid"] ), ARRAY_N );
      ?>
      <style>
          .sdgc-page-calendar-approvals{padding:30px;}
      </style>
      <div class="sdgc-page-calendar-approvals">
      <form method="post">
      <?php
      if ( $recordcount >= 0 && (!isset($delete) || !$delete)) {
          $filterText = $filterStatus == "1" ? "needs approval" : ($filterStatus == "2" ? "are approved" : ($filterStatus == "-1" ? "have been removed" : "meet criteria"));
          echo "<strong>".$recordcount." custom event(s) ".$filterText.".</strong>";
      }
      $args = array(
	      'post_type' => 'sd-google-calendars'
      );
      $post_query = new WP_Query($args);
      $calendarMap = [];
      if($post_query->have_posts() ) {
	      while ( $post_query->have_posts() ) {
		      $post_query->the_post();
		      $calendarMap[get_the_ID()] = get_the_title();
	      }
      }
      ?>
      <script>
          function selectAll(val){
              jQuery("input[name='selectedEvents[]']").each(function(){
                  this.checked = !this.checked;
              });
          }
      </script>
      <div class="container">
        <div class="row">
          <div class="col-md-4">
              <label for="sdgc-approval-option">Action:</label>
              <select name="sdgc-approval-option" id="sdgc-approval-option" class="btn btn-default">
                  <option value="spam">Remove Events</option>
                  <option value="approve">Approve Events</option>
                  <option value="delete">Delete Events</option>
              </select>
              <button type="submit" name="submit_action" value="action" class="btn btn-info">Submit</button>
              <br><i>*'Delete Events' cannot be undone</i>
          </div>
          <div class="col-md-4">
              <label for="sdgc-approval-status">Filter by:</label>
              <select name="sdgc-approval-status" id="sdgc-approval-status" class="btn btn-default">
                <option value="1" <?php echo $filterStatus == "1" ? "selected" : ""; ?>>Needs Approval</option>
                <option value="2" <?php echo $filterStatus == "2" ? "selected" : ""; ?>>Approved Events</option>
                <option value="-1" <?php echo $filterStatus == "-1" ? "selected" : ""; ?>>Removed Events</option>
              </select>
              <button type="submit" name="submit_action" value="filter" class="btn btn-info">Filter</button>
          </div>
          <div class="col-md-4">
              <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#addNewModal">
                  Add New
              </button>
          </div>
        </div>
      <?php
          $results = $wpdb->get_results( $wpdb->prepare( "SELECT id,startdate,starttime,enddate,endtime,summary,description,location,map,postid FROM {$table_name} where customentry = %s order by id desc limit ".(($page-1)*$pageRecords).", ".$pageRecords, $filterStatus ), ARRAY_A );
          if(count($results)>0){
              echo "<table class=\"table table-striped\">";
              echo "<thead><tr><th style='text-align:center'><input type='checkbox' onclick='selectAll(this.checked)'/>Select All</th><th>Title</th><th>Summary</th>".
                "<th>Calendar</th><th>Start</th><th>End</th><th>Location</th>".
                "</tr></thead>";
              foreach($results as $key => $evt){
                  echo "<tr ".($filterStatus == "-1" ?  "style='text-decoration: line-through;'" : "").">".
                    "<th scope='row'><input type='checkbox' name='selectedEvents[]' id='selectedEvents' value='".$evt["id"]."'/></th>".
                    "<td>".$evt["summary"]."</td>".
                    "<td>".$evt["description"]."</td>".
                    "<td>".(isset($calendarMap[$evt["postid"]]) ? $calendarMap[$evt["postid"]] : "")."</td>".
                    "<td>".DateTime::createFromFormat('Y-m-d',$evt["startdate"])->format("m/d/Y")."<br/>".
                        DateTime::createFromFormat('H:i:s',$evt["starttime"])->format("h:i A").
                    "</td>".
                    "<td>".
                       DateTime::createFromFormat('Y-m-d',$evt["enddate"])->format("m/d/Y")."<br/>".
                       DateTime::createFromFormat('H:i:s',$evt["endtime"])->format("h:i A")."</td>".
                    "<td><a href='".$evt["map"]."' target='_blank'>".$evt["location"]."</a></td>".
                    "</tr>";
              }
              echo "</table>";
          }else{
              echo "<strong>No events meet the criteria.</strong>";
          }

          if($recordcount > $pageRecords) {
	          $pages = ceil( $recordcount / $pageRecords );
	          ?>
              <table class="table" style="width: 40%;margin: 0px auto;float: none;">
                  <tr>
                      <td>Page:</td>
                      <?php
                      for ( $i = 1; $i <= $pages; $i ++ ) {
                          echo "<td>";
                          if ( $page == $i ) {
                              echo "<input type='button' name='page' class='btn btn-default disabled' value='" . $i . "'/>";
                          } else {
                              echo "<input type='submit' name='page' class='btn btn-default' value='" . $i . "'/>";
                          }
                          echo "</td>";
                      }
                      ?>
                  </tr>
              </table>
	          <?php
          }
        ?>
      </div>
      </form>

          <style>
              .modal-body .container{
                  max-width: 85% !important;
              }
              .modal-body .container .row{
                  padding: 9px !important;
              }
              .modal-body .datecol{
                  min-width:150px;
              }
              .modal-body *{
                  -webkit-box-sizing: content-box;
                  -moz-box-sizing: content-box;
                  box-sizing: content-box;
              }
          </style>
          <script>
              function validateNewEventForm(){
                  jQuery.post("<?php echo get_site_url().'/wp-json/sd-google-calendar/v1/sdcalendar/newevent'; ?>", {//window.location.pathname, {
                      //"addnewevent":true
                    'summary' : jQuery("#summary").val(),
                    'description' : jQuery("#description").val(),
                    'startdate' : jQuery("#startdate").val(),
                    'starttime' : jQuery("#starttime").val(),
                    'enddate' : jQuery("#enddate").val(),
                    'endtime' : jQuery("#endtime").val(),
                    'location' : jQuery("#location").val(),
                    'map' : jQuery("#mapurl").val(),
                    'calendarid' : jQuery("#selectedcalendar option:checked").val(),
                    'customentry' : 2
                  }).done(function( data ) {
                      var result = JSON.parse(data);
                      if(result["success"]){
                          jQuery('#new_event_form')[0].reset();
                          jQuery("#addNewModal").modal('toggle');
                          location.reload();
                      }else{
                          jQuery("#new_event_error").html("<div class=\"alert alert-danger\" role=\"alert\">\n" +
                              "<strong>Error!</strong> There was an error submitting your event, try again later." +
                              "</div>");
                      }
                  });
                  //$("#new_event_form").submit();
              }
          </script>
          <div id="addNewModal" class="modal fade" tabindex="-1" role="dialog" aria-labelledby="addNewModalLabel">
              <div class="modal-dialog" role="document">
                  <div class="modal-content">
                      <div class="modal-header">
                          <h5 class="modal-title" id="addNewModalLabel">Add New Event</h5>
                          <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">×</span></button>
                      </div>
                      <div class="modal-body">
                          <div class="container-fluid bd-example-row">
                              <div class="row">
                                  <div class="col-md-10">
                                      <label for="calendar">Calendar</label>
                                      <select name="selectedcalendar" id="selectedcalendar">
                                        <?php
                                        foreach($calendarMap as $key => $val){
                                            echo "<option value='".$key."'>".$val."</option>";
                                        }
                                        ?>
                                      </select>
                                  </div>
                              </div>
                            <?php
                            include 'sdgc_new_event.php';
                            ?>
                          </div>
                      </div>
                      <div class="modal-footer">
                          <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                          <button type="button" class="btn btn-primary">Save changes</button>
                      </div>
                  </div>
              </div>
          </div>


      </div>




      <?php


//		echo '<div class="sd-calendar-combined-div wrap" style="margin:10px;">';
//		echo '<form method="post">';
//		wp_nonce_field( 'sdgc_save_meta_box_data', 'sdgc_meta_box_nonce' );
//		echo '<h1>Settings for the Google Calendar combiner.</h1>'.
//		     '<table class="form-table sdgc-calendar-fields">'.
//		     '   <tbody>'.
//		     '       <tr>'.
//		     '       	<th scope="row">Update Rate</th>'.
//		     '        <td><select name="sdgc_cron_option"><option value="hourly" '.($cronCycle == "hourly" ? 'selected' : '').'>Hourly</option>'.
//		     '						<option value="twicedaily" '.($cronCycle == "twicedaily" ? 'selected' : '').'>Twice Daily</option>'.
//		     '            <option value="daily" '.($cronCycle == "daily" ? 'selected' : '').'>Daily</option></select></td>';
//		echo '</tr>'.
//		     '<tr><th scope="row">Google Server Key<br/><i>Must have Google Maps API enabled</i></th><td>'.
//		     '<input type="text" name="sdgc_googlekey_option" placeholder="Server API Key" value="'.(!empty(get_option('sdgc_googlekey_option')) ? get_option('sdgc_googlekey_option') : '').'"/></td></tr>'.
//		     '</tbody></table>';
//		submit_button();
//		echo "</form>";
//		echo '</div>';
	}

	function sdgc_admin_menu_routes(){}
	
	function sdgc_register_post_type() {
		$labels = array(
			'name'               => _x( 'Google Calendars', 'post type general name', TEXTDOMAIN ),
			'singular_name'      => _x( 'Google Calendar', 'post type singular name', TEXTDOMAIN ),
			'menu_name'          => _x( 'Google Calendars', 'admin menu', TEXTDOMAIN ),
			'name_admin_bar'     => _x( 'Calendar', 'add new on admin bar', TEXTDOMAIN ),
			'add_new'            => _x( 'Add New', 'calendar', TEXTDOMAIN ),
			'add_new_item'       => __( 'Add New Calendar',  TEXTDOMAIN ),
			'new_item'           => __( 'New Calendar', TEXTDOMAIN ),
			'edit_item'          => __( 'Edit Calendar', TEXTDOMAIN ),
			'view_item'          => __( 'View Calendar', TEXTDOMAIN ),
			'all_items'          => __( 'All Calendars', TEXTDOMAIN ),
			'search_items'       => __( 'Search Calendars', TEXTDOMAIN ),
			'parent_item_colon'  => __( 'Parent Calendars:', TEXTDOMAIN ),
			'not_found'          => __( 'No calendars found.', TEXTDOMAIN ),
			'not_found_in_trash' => __( 'No calendars found in Trash.', TEXTDOMAIN )
		);

		$args = array(
			'labels'             => $labels,
			'description'        => __( 'Description.', 'Combine Google Calendars for display on your website.' ),
			'public'             => false,
			'publicly_queryable' => false,
			'show_ui'            => true,
			'show_in_menu'       => false,
			'query_var'          => false,
			'rewrite'            => array( 'slug' => 'sd-google-calendars' ),
			'capability_type'    => 'post',
			'has_archive'        => true,
			'hierarchical'       => false,
			'menu_position'      => null,
			'supports'           => array( 'title' )
		);

		register_post_type( 'sd-google-calendars', $args );
	}
	
	function sdgc_meta_box_main_data() {
		$screens = array( 'sd-google-calendars' );
		foreach ( $screens as $screen ) {
			add_meta_box(
				'sdgc_calendar_builder',
				__( 'Combined Google Calendars', TEXTDOMAIN ),
				array( $this, 'sdgc_calendar_builder_callback' ),
				$screen
			);
			add_meta_box(
				'sdgc_calendar_output',
				__( 'Calendar Output', TEXTDOMAIN ),
				array( $this, 'sdgc_calendar_details_callback' ),
				$screen
			);
		}
	}
	
	function sdgc_calendar_builder_callback( $post ) {
		global $wpdb;
		// Add a nonce field so we can check for it later.
		wp_nonce_field( 'sdgc_save_meta_box_data', 'sdgc_meta_box_nonce' );
		$this->sdgc_include_custom_jquery();
		$output = '';
		?>
		<style>
			.sdgc-container .url-column{
				float: left;
				width: 50%;
				clear: both;
			}
			.sdgc-container .content-column{
				float: left;
				width: 40%;
				padding: 10px;
			}
			.sdgc-container .content-column ul{
			    margin: 0px;
			}
			.sdgc-container .content-column ul li {
			    background: #F1F1F1;
			    display: block;
			    padding: 10px;
			    margin-bottom: 0px;
			    border: 1px solid #E5E5E5;
			    border-left: none;
			    border-top: none;
			}
			.sdgc-container .content-column ul li a{
				text-decoration: none;
			}
			.sdgc-container .content-column ul li:hover{
				background: #E5E5E5;
				cursor: pointer;
			}
			.sdgc-container .content-column ul .item-active{
				background: #E5E5E5;
				cursor: pointer;
			}
			#sdgc_calendar_builder .inside{
				margin: 0px;
				padding: 0px;
			}
			#sdgc_calendar_builder .clean{
				clear: both;
			}
			#sdgc_calendar_builder .form-table th{
				padding: 0px;
			}
			#sdgc_calendar_builder .form-table td{
				padding: 0px;
			}
			.sdgc-calendar-fields td{
				padding: 0px;
			}
		}
		</style>
        <script>
            jQuery( document ).ready(function() {
                var counter = 0;
                jQuery( "a.sdgc-add-item" ).click(function(event) {
                    jQuery("#sdgc_calendar_fields").append("<fieldset><table><tr><th>Google Calendar ID</th></tr><tr><td><input type=\"email\" id=\"sdgc_calendar_url_new_"+counter+"\" name=\"sdgc_calendar_urls[]\" placeholder=\"(ex: test@group.calendar.google.com)\" size=\"50\"/></td></tr></table></fieldset>");
                    counter = counter + 1;
                });
                jQuery(".sdgc-remove-item").click(function(event){
                    jQuery("#sdgc_calendar_fieldset_"+jQuery(this).data("sdgc-field")).remove();
                })
            });
        </script>
<?php
		$value = get_post_meta( $post->ID, '_my_meta_value_key', true );
		$post_fields_arr = $this->default_fields;
		$custom_fields_query = $wpdb->get_results('SELECT distinct( meta_key ) FROM '.$wpdb->postmeta.' WHERE meta_key NOT LIKE "\_%"', ARRAY_N);
		$custom_fields_arr = array();
		foreach ($custom_fields_query as $key => $value) {
			foreach ($value as $key2 => $value2) {
				$custom_fields_arr[] = $value2;
			}
		}
		$post_fields_urls = unserialize( get_post_meta($post->ID, '_sdgc_calendar_urls', true) );
        $post_fields_color = unserialize( get_post_meta($post->ID, '_sdgc_calendar_color', true) );
		//$post_fields_colors = unserialize( get_post_meta($post->ID, '_sdgc_calendar_colors', true) );
		$post_fields_timezone = unserialize( get_post_meta($post->ID, '_sdgc_calendar_timezone', true) );
		$post_fields_numdaysback = unserialize( get_post_meta($post->ID, '_sdgc_calendar_numdaysback', true) );
		$post_fields_numdaysahead = unserialize( get_post_meta($post->ID, '_sdgc_calendar_numdaysahead', true) );

        $post_fields_lastrun_startdate = get_post_meta($post->ID, '_sdgc_calendar_lastrun_startdate', true);
        $post_fields_lastrun_enddate = get_post_meta($post->ID, '_sdgc_calendar_lastrun_enddate', true);
        $post_fields_lastrun_isrunning = get_post_meta($post->ID, '_sdgc_calendar_lastrun_isrunning', true);
        $post_fields_lastrun_lastdateupdated = get_post_meta($post->ID, '_sdgc_calendar_lastrun_lastupdateddate', true);
        $post_fields_lastrun_finisheddate = get_post_meta($post->ID, '_sdgc_calendar_lastrun_finishdate', true);

		$post_fields_arr = array_merge($post_fields_arr, $custom_fields_arr);
		$max_fields = 1;
		?>
		<div class="sd-calendar-combined-div" style="margin:10px;">
		    <p>Define Google Calendars you want to combine.</p>
            <table class="form-table sdgc-calendar-fields">
            <tbody>
                <tr>
                    <th scope="row">Timezone</th>
                    <td id="sdgc_calendar_timezone">
<?php
				        		$utc = new DateTimeZone('UTC');
								$dt = new DateTime('now', $utc);
								echo '<select name="sdgc_calendar_timezone">';
								foreach(DateTimeZone::listIdentifiers() as $tz) {
									$current_tz = new DateTimeZone($tz);
									$offset =  $current_tz->getOffset($dt);
									$transition =  $current_tz->getTransitions($dt->getTimestamp(), $dt->getTimestamp());
									$abbr = $transition[0]['abbr'];
									echo '<option value="' .$tz. '" '.(strcmp($tz,$post_fields_timezone) == 0 ? 'selected' : ''). '>' .$tz. ' [' .$abbr. ' '. $this->formatOffset($offset). ']</option>';
								}
								echo '</select><br/><br/>';
?>
                    </td>
                </tr>
                <tr>
                  <th scope="row">Days (Max: 365)</th>
                    <td>Days of events stored locally in advance from current day to display (in Agenda mode):<br/>
                        Days Before Today:
                        <input type="number" name="sdgc_calendar_numdaysback" id="sdgc_calendar_numdaysback" value="<?php echo (!empty($post_fields_numdaysback) ? $post_fields_numdaysback : 30); ?>" placeholder="# of Days Back"/>
                        <br/>
                        Days After Today:
                        <input type="number" name="sdgc_calendar_numdaysahead" id="sdgc_calendar_numdaysahead" value="<?php echo (!empty($post_fields_numdaysahead) ? $post_fields_numdaysahead : 30); ?>" placeholder="# of Days Ahead"/>
                        <br/><br/>
                    </td>
                </tr>
                <tr>
                    <th scope="row">Calendars</th>
                    <td id="sdgc_calendar_fields">
<?php
                        $i = 0;
                        if($post_fields_urls){
                            foreach ($post_fields_urls as $key => $value) {
                                $i++;
?>
								<fieldset id="sdgc_calendar_fieldset_'.$i.'">
                                    <table>
                                        <tr><th>Google Calendar ID &nbsp;&nbsp<input type="color" id="sdgc_calendar_color_<?php echo $i;?>" name="sdgc_calendar_color[]" value="<?php echo $post_fields_color[$key]; ?>" style="min-height: 27px;padding: 1px;">Color</th><th></th></tr>
                                        <tr><td><input type="email" id="sdgc_calendar_url_<?php echo $i;?>" name="sdgc_calendar_urls[]" value="<?php echo $value; ?>" placeholder="(ex: test@group.calendar.google.com)" size="50"/></td>
                                            <td><a class="sdgc-remove-item button button-small" data-sdgc-field="<?php echo $i;?>">Delete</a></td>
                                        </tr>
                                    </table>
                                </fieldset>
                                <br/>
<?php
									//<th>Text Color</th>
									//<td><input type="text" class="jscolor" id="sdgc_calendar_color_'.$i.'" name="sdgc_calendar_colors[]" value="'.$post_fields_colors[$key].'" placeholder="000000"/></td>
								}
							}else{
								$i = 1;
?>
    							<fieldset id="sdgc_calendar_fieldset_<?php echo $i;?>">
									<table>
										<tr><th>Google Calendar ID &nbsp;&nbsp<input type="color" id="sdgc_calendar_color_<?php echo $i;?>" name="sdgc_calendar_color[]" value="#ff0000" style="min-height: 27px;padding: 1px;">Color</th><th></th></tr>
										<tr><td><input type="email" id="sdgc_calendar_url_<?php echo $i;?>" name="sdgc_calendar_urls[]" placeholder="(ex: test@group.calendar.google.com)" size="50"/></td>
											<td><a class="sdgc-remove-item button button-small" data-sdgc-field="<?php echo $i;?>">Delete</a></td>
					  					</tr>
					  				</table>
								</fieldset>
								<br/>
<?php
								//<th>Text Color</th>
								//<td><input type="text" class="jscolor" id="sdgc_calendar_color_'.$i.'" name="sdgc_calendar_colors[]" placeholder="000000"/></td>
							}
?>
                    </td>
                </tr>
                <tr>
                    <th></th>
                    <td class="sdgc-add-field">
                        <a class="sdgc-add-item button button-primary button-large">Add Another Calendar</a>
                    </td>
                </tr>
            </tbody>
        </table><br/><br/>
        <p>*<i>Publish to see changes.</i></p>
        <table style="text-align:center;" cellspacing="8"><tr><td colspan="10" scope="row">Last Cron Run</td></tr>
            <tr><th scope="row">Calendar Start Date</th><th>Calendar End Date</th><th>Last Updated Date</th><th>Last Run</th><th>Running?</th></tr>
            <tr>
                <td scope="row"><?php echo (!empty($post_fields_lastrun_startdate) ? $post_fields_lastrun_startdate->format("m/d/Y") : '');?></td>
                <td><?php echo (!empty($post_fields_lastrun_enddate) ? $post_fields_lastrun_enddate->format("m/d/Y") : '');?></td>
                <td><?php echo (!empty($post_fields_lastrun_lastdateupdated) ? $post_fields_lastrun_lastdateupdated->format("m/d/Y") : '');?></td>
                <td><?php echo (!empty($post_fields_lastrun_finisheddate) ? $post_fields_lastrun_finisheddate->format("m/d/Y H:i:s") : '');?></td>
                <td><?php echo (!empty($post_fields_lastrun_isrunning) ? ($post_fields_lastrun_isrunning ? 'Yes' : 'No') : '');?></td>
            </tr>
        </table>
        </div>
<?php
			  //<th>Text Color</th>
			  //<td><input type=\"text\" class=\"jscolor\" id=\"sdgc_calendar_color_new_"+counter+"\" name=\"sdgc_calendar_colors[]\" placeholder=\"000000\" value=\"000000\"/></td>
		echo $output;
	}

	function sdgc_addCalendarEventTable(){
		global $wpdb;
		global $sdgc_db_version;
		$table_name = $wpdb->prefix . "sdgc_events";
		$charset_collate = $wpdb->get_charset_collate();
		$sql = "CREATE TABLE IF NOT EXISTS ".$table_name." (".
			"id int(20) NOT NULL AUTO_INCREMENT,".
			"calendar varchar(120) NOT NULL,".
		    "eventid varchar(100) NOT NULL,".
			"startdate date NOT NULL,".
			"starttime time DEFAULT NULL,".
			"enddate date DEFAULT NULL,".
			"endtime time DEFAULT NULL,".
			"summary text,".
			"description text,".
			"location text,".
			"map text,".
		    "importdate datetime DEFAULT '0000-00-00 00:00:00' NOT NULL,".
		    "postid int(20) DEFAULT NULL,".
            "customentry int(1) DEFAULT 0,".
		    "PRIMARY KEY (id)".
			") ".$charset_collate;

		require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
		dbDelta( $sql );
		add_option( 'sdgc_db_version', $sdgc_db_version );
	}

	function sdgc_setupCron(){
		//if( WP_DEBUG ){
		//
		//}
		//$this->sdgc_cronScheduleJob();
		//my_log_file("*setupCron()*");
		wp_clear_scheduled_hook('sdgc_cronScheduleJob');
		//if( !wp_next_scheduled( 'sdgc_cronScheduleJob' ) ) {
		wp_schedule_event( time(), get_option('sdgc_cron_option'), 'sdgc_cronScheduleJob' );
		//}
	}

	function sdgc_cronScheduleJob(){
		//my_log_file("* sdgc_cronScheduleJob *");
		global $wpdb;
		$args = array(
			'post_type' => 'sd-google-calendars'
		);
		$table_name = $wpdb->prefix . "sdgc_events";
		$post_query = new WP_Query($args);
		if($post_query->have_posts() ) {
			while($post_query->have_posts() ) {
				$post_query->the_post();
				$numdaysback = intval(unserialize( get_post_meta(get_the_ID(), '_sdgc_calendar_numdaysback', true) ));
				$numdaysahead = intval(unserialize( get_post_meta(get_the_ID(), '_sdgc_calendar_numdaysahead', true) ));
				update_post_meta( get_the_ID(), '_sdgc_calendar_lastrun_startdate', date_sub(new DateTime(date('m/d/Y')), new DateInterval( 'P' . abs( -$numdaysback ) . 'D' )) );
                update_post_meta( get_the_ID(), '_sdgc_calendar_lastrun_enddate', date_add(new DateTime(date('m/d/Y')), new DateInterval( 'P' . abs( $numdaysahead ) . 'D' )) );
                update_post_meta( get_the_ID(), '_sdgc_calendar_lastrun_isrunning', true );
				//schedule everything from numdaysback to numdaysahead 1 day at a time
				for ($day = -$numdaysback; $day <= $numdaysahead; $day++) {
					if($day<0) {
						$from = date_sub( new DateTime(date('Ymd')), new DateInterval( 'P' . abs( $day ) . 'D' ) );
					}else {
						$from = date_add( new DateTime(date('Ymd')), new DateInterval( 'P' . $day . 'D' ) );
					}
					$to = clone $from;
					date_add( $to, new DateInterval( 'P1D' ) ); //get 1 day at a time from the agenda
					//delete the old events for this batch on this day
					$wpdb->delete($table_name, array('postid'=>get_the_ID(),'startdate'=>$from->format( 'Y-m-d' ),'customentry'=>0));
					//get the new events for this batch on this day
					$calendarurl = $this->getCustomCalendarUrl( get_the_ID(), $from, $to);
					if ( ! empty( $calendarurl ) ) {
						$html = $this->getCustomCalendarDom( $calendarurl );
						foreach ( $html->find( 'div.date-section' ) as $element ) {
							//$dt = date_format(date_create_from_format('D M d, Y T',$element->find('div.date',0)->innertext . ' EST'), "Y-m-d");
							foreach ( $element->find( 'tr.event' ) as $event ) {
								$lnk = "https://calendar.google.com/calendar/" . $event->find( 'a.event-link', 0 )->href;
								$this->sdgc_addCalendarEvent( $this->getCalendarEventDescription( get_the_ID(), $lnk ), get_the_ID() );
							}
						}
					}
                    update_post_meta( get_the_ID(), '_sdgc_calendar_lastrun_lastupdateddate', $to );
				}
                update_post_meta( get_the_ID(), '_sdgc_calendar_lastrun_isrunning', false );
                update_post_meta( get_the_ID(), '_sdgc_calendar_lastrun_finishdate', new DateTime(date('m/d/Y H:i:s')) );
			}
		}
	}

	function sdgc_addCalendarEvent($evt, $postid = null){
		global $wpdb;
		if(isset($evt["startDate"])) {
			$table_name = $wpdb->prefix . "sdgc_events";
			$now        = current_time( 'mysql' );
			$results = $wpdb->get_results( $wpdb->prepare( "SELECT count(*) FROM {$table_name} where eventid = %s", $evt["eventid"] ), ARRAY_N );
			if ( $results[0][0] == 0 ) {
				$wpdb->insert(
					$table_name,
					array(
						'importdate'  => $now,
						'eventid'     => $evt["eventid"],
						'calendar'    => $evt["calendar"],
						'startdate'   => DateTime::createFromFormat( 'n/j/Y', $evt["startDate"] )->format( 'Y-m-d' ),
						'starttime'   => isset( $evt["startTime"] ) ? DateTime::createFromFormat( 'ga', $evt["startTime"] )->format( 'H:i:s' ) : null,
						'enddate'     => isset( $evt["endDate"] ) ? DateTime::createFromFormat( 'n/j/Y', $evt["endDate"] )->format( 'Y-m-d' ) : null,
						'endtime'     => isset( $evt["endTime"] ) ? DateTime::createFromFormat( 'ga', $evt["endTime"] )->format( 'H:i:s' ) : null,
						'summary'     => $evt["summary"],
						'description' => $evt["description"],
						'location'    => $evt["location"],
						'map'         => $evt["map"],
						'postid'      => $postid
					)
				);
			}
		}
	}
	
	function formatOffset($offset) {
        $hours = $offset / 3600;
        $remainder = $offset % 3600;
        $sign = $hours > 0 ? '+' : '-';
        $hour = (int) abs($hours);
        $minutes = (int) abs($remainder / 60);
        if ($hour == 0 AND $minutes == 0) {
            $sign = ' ';
        }
        return $sign . str_pad($hour, 2, '0', STR_PAD_LEFT) .':'. str_pad($minutes,2, '0');
	}
	
	function sdgc_calendar_details_callback( $post ) {

        wp_register_script('prefix_moments', '//cdnjs.cloudflare.com/ajax/libs/moment.js/2.14.1/moment.min.js');
        wp_enqueue_script('prefix_moments');
        wp_register_style('calendar_monthly_style', SDGC_URL."/css/monthly.css");
        wp_enqueue_style('calendar_monthly_style');
        wp_register_script('calendar_monthly_script', SDGC_URL."/js/monthly.js");
        wp_enqueue_script('calendar_monthly_script');
        wp_register_script('calendar_tinycolor', SDGC_URL."/js/tinycolor.js");
        wp_enqueue_script('calendar_tinycolor');
		echo '<p>Use the following shortcode: </p>';
		echo '<strong>[sd_show_calendar id="'.$post->ID.'"]</strong>';
		echo '<br/><p>Other attributes:</p>
			  <ul>
				<li><strong>type</strong> = "monthly" displays the calendar as a clickable monthly grid calendar with events on the calendar. (default)</li>
				<li><strong>type</strong> = "agenda" displays the calendar as an agenda list for the number of days defined.</li>
				<li><strong>type</strong> = "form" displays an entry form for entering a title, description, date/time, and location.</li>
			  </ul>';
		echo '<p>JSON Using REST v2 API: <a target="_blank" href="'.get_site_url().'/wp-json/sd-google-calendar/v1/sdcalendar/'.$post->ID.'">'.get_site_url().'/wp-json/sd-google-calendar/v1/sdcalendar/'.$post->ID.'</a></p>';
//			  <a target="_blank" href="'.site_url().'/wp-json/rest-routes/v2/'.$post->post_name.'">'.site_url().'/wp-json/rest-routes/v2/'.$post->post_name.'</a></p>';
?>
		<div style="width:100%; display:inline-block;">
			<div class="monthly" id="mycalendar"></div>
		</div>
		<script type="text/javascript">
        jQuery(document).ready( function($) {
            $('#mycalendar').monthly({
                mode: 'event',
                //jsonUrl: '<?php echo get_site_url()."/wp-admin/admin-ajax.php?action=sdgc_eventsjson_post&id=".$post->ID; ?>',//'events.json',
								//'/wp-json/sd-google-calendar/v1/sdcalendar/monthly/'.$post->ID
                //dataType: 'json'
                //xmlUrl: '<?php echo get_site_url().'/wp-json/sd-google-calendar/v1/sdcalendar/monthly/xml/'.$post->ID; ?>',//'events.xml'
                xmlUrl: '<?php echo get_site_url()."/wp-admin/admin-ajax.php?action=sdgc_eventsxml_post&id=".$post->ID; ?>',
                //linkCalendarToEventUrl: true,
                showDescriptionModal: true
            });
            $('#mycalendar2').monthly({
                mode: 'picker',
                target: '#mytarget',
                setWidth: '250px',
                startHidden: true,
                showTrigger: '#mytarget',
                stylePast: true,
                disablePast: true
            });
            switch(window.location.protocol) {
                case 'http:':
                case 'https:':
                    // running on a server, should be good.
                    break;
                case 'file:':
                    alert('Just a heads-up, events will not work when run locally.');
            }
        });
		</script>
<?php
	}
	
	function sdgc_save_meta_box_data( $post_id ) {
		// Check if our nonce is set.
		if ( ! isset( $_POST['sdgc_meta_box_nonce'] ) ) {
			return;
		}
		// Verify that the nonce is valid.
		if ( ! wp_verify_nonce( $_POST['sdgc_meta_box_nonce'], 'sdgc_save_meta_box_data' ) ) {
			return;
		}
		// If this is an autosave, our form has not been submitted, so we don't want to do anything.
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) {
			return;
		}
		// Check the user's permissions.
		if ( isset( $_POST['post_type'] ) && 'sd-google-calendars' == $_POST['post_type'] ) {
			if ( ! current_user_can( 'edit_page', $post_id ) ) {
				return;
			}
		} else {
			if ( ! current_user_can( 'edit_post', $post_id ) ) {
				return;
			}
		}
		//add_action( 'sdgc_save_fields', array($this, 'calendar_save_output'), 10, 2 );
			
			echo $post_id;
		do_action( 'sdgc_save_fields', $_POST, $post_id );
	}
	
	function calendar_save_output( $fields, $post_id ){
		$timezone = serialize( $fields['sdgc_calendar_timezone'] );
		update_post_meta( $post_id, '_sdgc_calendar_timezone', $timezone );
		
		$numdaysahead = serialize( $fields['sdgc_calendar_numdaysahead'] );
		if(empty($numdaysahead)) $numdaysahead = 30;
		else{
			if($numdaysahead < 0) $numdaysahead *= -1;
			if($numdaysahead > 365) $numdaysahead = 365;
		}
		update_post_meta( $post_id, '_sdgc_calendar_numdaysahead', $numdaysahead );

		$numdaysback = serialize( $fields['sdgc_calendar_numdaysback'] );
		if(empty($numdaysback)) $numdaysback = 30;
		else{
			if($numdaysback < 0) $numdaysback *= -1;
			if($numdaysback > 365) $numdaysback = 365;
		}
		update_post_meta( $post_id, '_sdgc_calendar_numdaysback', $numdaysback );

		$urls = serialize( $fields['sdgc_calendar_urls'] );
		update_post_meta( $post_id, '_sdgc_calendar_urls', $urls );


        $colors = serialize( $fields['sdgc_calendar_color'] );
        update_post_meta( $post_id, '_sdgc_calendar_color', $colors );
		
// 		$colors = serialize( $fields['sdgc_calendar_colors'] );
// 		update_post_meta( $post_id, '_sdgc_calendar_colors', $colors );
	}	
	
	function showcalendartag_func( $atts ) {
		$atts = shortcode_atts( array(
			'id' => -1,
			'type' => "monthly"
		), $atts, 'sd_show_calendar' );
		if(isset($atts['id']) && $atts['id']*1>=0){
			if(strcmp($atts['type'], "agenda") == 0){
				return $this->getAgendaFromCalendar($atts['id']);
			}else if(strcmp($atts['type'], 'monthly') == 0){
			    return $this->getCalendarDisplay($atts['id']);
            }
		}
        if(strcmp($atts['type'], 'form') == 0){
            return $this->getCalendarEntryForm($atts['id']);
        }
		return "";
	}
	
	public static function getCustomCalendarUrl($postId, $fromDate = null, $toDate = null){
		$cal_urls = unserialize( get_post_meta($postId, '_sdgc_calendar_urls', true) );
		$cal_colors = unserialize( get_post_meta($postId, '_sdgc_calendar_colors', true) );
		$timezone = unserialize( get_post_meta($postId, '_sdgc_calendar_timezone', true) );
		date_default_timezone_set($timezone);
		//$numdays = unserialize( get_post_meta($postId, '_sdgc_calendar_numdays', true) );
		$firstDate = isset($fromDate) ? $fromDate : new DateTime(date('Ymd'));
		$secondDate = isset($toDate) ? $toDate : date_add($firstDate, new DateInterval('P1D'));
		//$futureDate = date_add($currentDate, new DateInterval('P'.$numdays.'D'));
		$dates = $firstDate->format('Ymd')."/".$secondDate->format('Ymd');
		//dates=20160530/20160630
		if($cal_urls){
			$calendarurl = "https://calendar.google.com/calendar/htmlembed?mode=AGENDA&";
			$calendarurl .= "ctz=".urlencode($timezone)."&";
			$calendarurl .= "dates=".$dates."&";
			$i=0;
			foreach ($cal_urls as $key => $value) {
				$calendarurl .= "src=".urlencode($value)."&color=".urlencode("#".$cal_colors[$i])."&";
				$i++;
			}
			return $calendarurl;
		}
		return null;
	}

	public static function getCustomCalendarDom($calendarUrl){
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($curl, CURLOPT_HEADER, false);
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($curl, CURLOPT_URL, $calendarUrl);
		curl_setopt($curl, CURLOPT_REFERER, $calendarUrl);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, TRUE);
		$str = curl_exec($curl);
		curl_close($curl);
		$html = new simple_html_dom();
		$html->load($str);
		return $html;
	}

	function getCalendarEventDescription($postId, $url){
		$timezone = unserialize( get_post_meta($postId, '_sdgc_calendar_timezone', true) );
		date_default_timezone_set($timezone);
		$tz = "ctz=".urlencode($timezone);
		$paramForXML = "sf=true&output=xml";
		$eventUrl = $url."&".$tz."&".$paramForXML;
		$curl = curl_init();
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_HEADER, false);
		curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
		curl_setopt($curl, CURLOPT_URL, $eventUrl);
		curl_setopt($curl, CURLOPT_REFERER, $eventUrl);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		$str = curl_exec($curl);
		curl_close($curl);
		$xml = new SimpleXMLElement($str);
		$result = [
			'eventid' => $xml->xpath('eid/value')[0],
			'calendar' => $xml->xpath('source-calendar/principal/value')[0],
			'startDate' => $xml->xpath('dates/start-date')[0],
			'endDate' => $xml->xpath('dates/end-date')[0],
			'startTime' => $xml->xpath('dates/start-time')[0],
			'endTime' => $xml->xpath('dates/end-time')[0],
			'summary' => $xml->xpath('summary/value')[0],
			'location' => $xml->xpath('location/value')[0],
			'map' => urldecode($xml->xpath('location/link')[0]),
			'description' => $xml->xpath('description/value')[0]
		];
		return $result;

	}
	
	function getAgendaFromCalendar($postId){
			wp_register_script('prefix_moments', '//cdnjs.cloudflare.com/ajax/libs/moment.js/2.14.1/moment.min.js');
			wp_enqueue_script('prefix_moments');
			wp_register_script('calendar_monthly_script', SDGC_URL."/js/monthly.js");
			wp_enqueue_script('calendar_monthly_script');
			wp_register_script('calendar_tinycolor', SDGC_URL."/js/tinycolor.js");
			wp_enqueue_script('calendar_tinycolor');
			wp_enqueue_script('jquery', 'https://ajax.googleapis.com/ajax/libs/jquery/3.1.1/jquery.min.js', array('jquery'), '3.1.1', true);
			wp_register_script('prefix_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js');
			wp_enqueue_script('prefix_bootstrap');
			wp_register_style('prefix_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css');
			wp_enqueue_style('prefix_bootstrap');

			$post_fields_urls = unserialize( get_post_meta($postId, '_sdgc_calendar_urls', true) );
			$post_fields_color = unserialize( get_post_meta($postId, '_sdgc_calendar_color', true) );
			$urlColorMap = [];
			foreach($post_fields_urls as $key => $url){
				$urlColorMap[$url] = $post_fields_color[$key];
			}


			global $wpdb;
			$table_name = $wpdb->prefix . "sdgc_events";
			$results = $wpdb->get_results( $wpdb->prepare( "SELECT id,calendar,startdate,starttime,enddate,endtime,summary,description,location,map FROM {$table_name} where startdate >= CURDATE() and postid = %d order by startdate asc, time(starttime) asc limit 20", $postId ), ARRAY_A );
			$output = "<ul class='sd-calendar-list'>";
			foreach ($results as $key => $res){
                $evtJSON = "{startDate: \"".$res["startdate"]."\", ".
                           "startTime: \"".date('g:i A', strtotime($res["starttime"]))."\", ".
                           "endDate: \"".$res["enddate"]."\",".
                           "endTime: \"".date('g:i A', strtotime($res["endtime"]))."\", ".
                           "title: \"".($res["summary"])."\", ".
                           "color: \"".$urlColorMap[$res["calendar"]]."\", ".
                           "id: ".$res["id"].", ".
                           "description: \"".($res["description"])."\", ".
                           "location: \"".($res["location"])."\", ".
                           "map: \"".$res["map"]."\"}";
                if ($key == 0){
	                $output .= "<li>";
	                $output .= "<span class='sd-date-text'>" . date("m/d/Y", strtotime($res["startdate"])) . "</span><br/>";
                }
                $output .= "<ul class='sd-date-events'>";//.date("m/d/Y", strtotime($res["startdate"])). "...".$results[$key+1]["startdate"];
                $output .= "<li><a href='#' id='agendaPage".$res["id"]."' data-eventid='".$res["id"]."' onmouseover='return showPopoverWithEventAsJson(".$res["id"].",".$evtJSON.")'>";
                $output .= "<span class='sd-date-event-time'>".date('g:i A', strtotime($res["starttime"]))."</span>";
                if(!empty($res["summary"])) {
	                $output .= "<span class='sd-date-event-title'>" . $res["summary"] . "</span>";
                }
                $output .= "</a></li>";
                $output .= "</ul>";
              if (isset($results[$key+1]) && $res["startdate"] != $results[$key+1]["startdate"]) {
                  $output .= "</li><li>";
                  $output .= "<span class='sd-date-text'>" . date("m/d/Y", strtotime($results[$key+1]["startdate"])) . "</span><br/>";
              }
              if (!isset($results[$key+1])) {
                  $output .= "</li>";
              }
			}
			$output .= "</ul>";
			return $output;



//		$calendarurl = $this->getCustomCalendarUrl($postId);
//	    //echo($calendarurl);
//		if(!empty($calendarurl)){
//			$html = $this->getCustomCalendarDom($calendarurl);
//			//$html = file_get_html($calendarurl);
//			$output = "<ul class='sd-calendar-list'>";
//			foreach($html->find('div.date-section') as $element){
//				$output .= "<li>";
//				$output .= "<span class='sd-date-text'>".date_format(date_create_from_format('D M d, Y T',$element->find('div.date',0)->innertext . ' EST'), "Y-m-d")."</span><br/>";
//				foreach($element->find('tr.event') as $event){
//				   $output .= "<ul class='sd-date-events'>";
//				   $output .= "<li><span class='sd-date-event-time'>".$event->find('td.event-time',0)->innertext."</span>";
//				   $output .= "<a class='sd-date-event-link' href='https://calendar.google.com/calendar/".$event->find('a.event-link',0)->href."'>";
//				   $output .= "<span class='sd-date-event-title'>".$event->find('span.event-summary',0)->innertext."</span>";
//				   $output .= "</a></li>";
//				   $output .= "</ul>";
//				}
//				$output .= "<br/></li>";
//			}
//			$output .= "</ul>";
//			return $output;
//		}
//		return "";
	}

	function getCalendarDisplay($postid){
        wp_register_script('prefix_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js');
        wp_enqueue_script('prefix_bootstrap');
        wp_register_style('prefix_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css');
        wp_enqueue_style('prefix_bootstrap');
        wp_register_script('prefix_moments', '//cdnjs.cloudflare.com/ajax/libs/moment.js/2.14.1/moment.min.js');
        wp_enqueue_script('prefix_moments');
        wp_register_style('calendar_monthly_style', SDGC_URL."/css/monthly.css");
        wp_enqueue_style('calendar_monthly_style');
        wp_register_script('calendar_monthly_script', SDGC_URL."/js/monthly.js");
        wp_enqueue_script('calendar_monthly_script');
        wp_register_script('calendar_tinycolor', SDGC_URL."/js/tinycolor.js");
        wp_enqueue_script('calendar_tinycolor');
?>
        <div style="width:100%; display:inline-block;">
            <div class="monthly" id="mycalendar"></div>
        </div>
        <script type="text/javascript">
            jQuery(document).ready( function($) {
                $('#mycalendar').monthly({
                    mode: 'event',
                    //jsonUrl: '<?php echo get_site_url()."/wp-admin/admin-ajax.php?action=sdgc_eventsjson_post&id=".$postid; ?>',//'events.json',
                    //'/wp-json/sd-google-calendar/v1/sdcalendar/monthly/'.$post->ID
                    //dataType: 'json'
                    //xmlUrl: '<?php echo get_site_url().'/wp-json/sd-google-calendar/v1/sdcalendar/monthly/xml/'.$postid; ?>',//'events.xml'
                    xmlUrl: '<?php echo get_site_url()."/wp-admin/admin-ajax.php?action=sdgc_eventsxml_post&id=".$postid; ?>',
                    //linkCalendarToEventUrl: true,
                    showDescriptionModal: true
                });
//                $('#mycalendar2').monthly({
//                    mode: 'picker',
//                    target: '#mytarget',
//                    setWidth: '250px',
//                    startHidden: true,
//                    showTrigger: '#mytarget',
//                    stylePast: true,
//                    disablePast: true
//                });
                switch(window.location.protocol) {
                    case 'http:':
                    case 'https:':
                        // running on a server, should be good.
                        break;
                    case 'file:':
                        alert('Just a heads-up, events will not work when run locally.');
                }
            });
        </script>
<?php
    }

    function getCalendarEntryForm($postid){
	    global $wpdb;
	    $table_name = $wpdb->prefix . "sdgc_events";
	    if(isset($_POST["summary"])) {
            $wpdb->insert($table_name, array(
                'summary' => $_POST["summary"],
                'description' => isset($_POST["description"]) ? $_POST["description"] : "",
                'startdate' => isset($_POST["startdate"]) ? $_POST["startdate"] : date_format(new DateTime(),"Y-m-d"),
                'starttime' => isset($_POST["starttime"]) ? $_POST["starttime"].":00" : "00:00:00",
                'enddate' => isset($_POST["enddate"]) && !strcmp($_POST["enddate"],"0000-00-00") ? $_POST["enddate"] : date_format(new DateTime(),"Y-m-d"),
                'endtime' => isset($_POST["endtime"]) ? $_POST["endtime"].":00" : "23:59:59",
                'location' => isset($_POST["location"]) ? $_POST["location"] : "",
                'map' => isset($_POST["mapurl"]) ? $_POST["mapurl"] : "",
                'postid' => $postid,
                'customentry' => 1
            ));
            $newentrypassed = true;
        }
        wp_register_script('prefix_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/js/bootstrap.min.js');
	    wp_enqueue_script('prefix_bootstrap');
        wp_register_style('prefix_bootstrap', '//maxcdn.bootstrapcdn.com/bootstrap/3.3.6/css/bootstrap.min.css');
	    wp_enqueue_style('prefix_bootstrap');
	    ?>
        <script>
            function validateNewEventForm(){
                jQuery("#new_event_form").submit();
            }
        </script>
        <?php

	    include 'sdgc_new_event.php';
    }


	/****

	function custom_get_route( WP_REST_Request $request) {

		global $wpdb;

		if( null !== $request->get_param( 'id' ) ){
			$route_info = $request->get_param( 'id' );
			$route = get_post( $route_info );

			if( $route != null ){
				$route_id = $route->ID;
			}else{
				$route_by_name = $wpdb->get_row( $wpdb->prepare( "SELECT * FROM $wpdb->posts WHERE post_name = %s", $route_info ) );
				$route_id = $route_by_name->ID;
			}

		}

	    return $this->wprr_get_posts($args, $route_id, $this->default_fields);
	}

	function wprr_filters(){

		foreach ( array_reverse( glob( WPRR_INC_PATH . '/filters/wprr-filter-*.php' ) ) as $filename ) {
			include $filename;
		}

	}

	function wprr_output( $post_id, $default_fields, $post_ids ){

		global $wpdb;

		$output_columns_db = unserialize( get_post_meta( $post_id, '_wprr_output_fields', true ) );

		$post_fields = array();
		$post_custom_fields = array();

		foreach ($output_columns_db as $key => $value) {
			if( (string) array_search($value, $default_fields) != '' ){
				$post_fields[] = $value;
			}else{
				$post_custom_fields[] = $value;
			}
		}

		$post_meta_key = array();
		$output_columns = '';

		if( isset($post_fields) ){
			$posts_table = $wpdb->posts . ' p';
			$output_columns .= 'p.' . implode( ", p.", $post_fields );

			if ($post_custom_fields){
				$output_columns .= ', ';
			}
		}

		if( isset($post_custom_fields) ){

			foreach ($post_custom_fields as $key => $value) {

				$output_columns .= "COALESCE( ( SELECT 
									meta_value
									FROM
									".$wpdb->postmeta." pm
									WHERE pm.post_id = p.ID
									AND pm.meta_key = '".$value."' ), '' ) as " . $value;

				if( $value != end( $post_custom_fields ) ){
					$output_columns .= ', ';
				}
		
			}
		}

		$output_query = $wpdb->get_results(
			"
			SELECT
			".$output_columns."
			FROM 
			".$posts_table."
			WHERE
			p.ID IN (".$post_ids.")
			"
		);

		if( count( $output_columns_db ) === 1 ){

			$output_one_column = array();

			foreach ( $output_query as $key => $value ) {
				$output_one_column[] = $value->$output_columns_db[0];
			}

			return $output_one_column;
			
		}else{

			return $output_query;

		}
	}

	function wprr_get_posts( $args, $post_id, $default_fields ){

		global $wpdb;

		$args['fields'] = 'ids';
		$args['posts_per_page'] = -1;

		//var_dump(apply_filters( 'wprr_filter_query', $args, $post_id ));

		$post_ids_query = new WP_Query( apply_filters( 'wprr_filter_query', $args, $post_id ) );

		$post_ids = implode(',', $post_ids_query->posts);

		return $this->wprr_output($post_id, $default_fields, $post_ids);
	}
	*****/
	
}

class SDGoogleCalendar_Custom_Route extends WP_REST_Controller {

	private static $instance;
	private static $myController = null;
	
	public static function init(){
		if(self::$instance == null){
			self::$instance = new SDGoogleCalendar_Custom_Route();
		}
		self::$instance->register_routes();
		return self::$instance;
	}
	
    /**
     * Register the routes for the objects of the controller.
     */
    public function register_routes() {
        $version = '1';
        $namespace = 'sd-google-calendar/v' . $version;
        $base = 'sdcalendar';

	    register_rest_route( $namespace, '/'.$base.'/newevent', array(
		    array(
			    'methods'             => WP_REST_Server::CREATABLE,
			    //'permission_callback' => array( $this, 'get_item_permissions_check' ),
			    'callback'            => array( $this, 'sdgc_newEvent' )
		    )
	    ) );
        register_rest_route( $namespace, '/'.$base.'/(?P<id>[\d]+)', array(
          array(
            'methods'         => WP_REST_Server::READABLE,
            'callback'        => array( $this, 'get_item' ),
            'permission_callback' => array( $this, 'get_item_permissions_check' ),
            'args'            => array(
							'context'          => array(
								'default'      => 'view',
							),
            ),
          )
        ) );
        register_rest_route( $namespace, '/'.$base.'/monthly/(?P<id>[\d]+)', array(
            array(
                'methods'         => WP_REST_Server::READABLE,
                'callback'        => array( $this, 'sdgc_eventsJSONForPost' ),
                'args'            => array(
                    'context'          => array('default'      => 'view'),
                ),
            )
        ));
        register_rest_route( $namespace, '/'.$base.'/monthly/xml/(?P<id>[\d]+)', array(
            array(
                'methods'         => WP_REST_Server::READABLE,
                'callback'        => array( $this, 'sdgc_eventsXMLForPost' )
            )
        ));

    }
    
    public function get_item_permissions_check( $request ) {
      return true; //<--use to make readable by all
      //return current_user_can( 'read_something' );
    }

    /**
     * Get post
     *
     * @param WP_REST_Request $request Full data about the request.
     * @return WP_Error|WP_REST_Response
     */
  public function get_items( $request ) {
    $items = array(); //do a query, call another class, etc
    $data = array();
    foreach( $items as $item ) {
      $itemdata = $this->prepare_item_for_response( $item, $request );
      $data[] = $this->prepare_response_for_collection( $itemdata );
    }

    return new WP_REST_Response( $data, 200 );
  }
    
  function get_item($request) {
	  $params = $request->get_params();
	  //$post = get_post($params['id']);
      //$output = $this->getCalendarPostAsJson($post);
	  //return $output;
	  return new WP_REST_Response( sdgc_eventsListAsJson($params['id']), 200 );
	}

	function sdgc_eventsJSONForPost($request){
		global $wpdb;
		$table_name = $wpdb->prefix . "sdgc_events";
		$params = $request->get_params();

		$results = $wpdb->get_results( $wpdb->prepare( "SELECT id,startdate,starttime,enddate,endtime,summary,description,location,map FROM {$table_name} where postid = %d", $params['id'] ), ARRAY_A );
		$json = '{ "monthly" : [';
		foreach ($results as $res){
			$evt = '{"id": "'.$res["id"].'","name": "'.$res["summary"].'", "startdate": "'.$res["startdate"].'", "starttime": "'.substr($res["starttime"],0,5).'", "enddate": "'.$res["enddate"].'", "endtime": "'.substr($res["endtime"],0,5).'" },';
			$json .= $evt;
//      "color": "#FFB128",
//      "url": ""
		}
		$json .= "] }";
		return new WP_REST_Response( $json, 200 );
	}
	function sdgc_eventsXMLForPost($request){
		global $wpdb;
		$table_name = $wpdb->prefix . "sdgc_events";
		$params = $request->get_params();

		$results = $wpdb->get_results( $wpdb->prepare( "SELECT id,startdate,starttime,enddate,endtime,summary,description,location,map FROM {$table_name} where postid = %d", $params['id'] ), ARRAY_A );
		$xml = '<?xml version="1.0"?><monthly>';
		foreach ($results as $res){
			$evt = '<event><id>'.$res["id"].'</id><name>'.$res["summary"].'</name><startdate>'.$res["startdate"].'</startdate><starttime>'.substr($res["starttime"],0,5).'</starttime><enddate>'.$res["enddate"].'</enddate><endtime>'.substr($res["endtime"],0,5).'</endtime></event>';
			$xml .= $evt;
//      "color": "#FFB128",
//      "url": ""
		}
		$xml .= "</monthly>";
		wp_die($xml);
		//$response = new WP_REST_Response( $xml );
		//return $response;
		return  rest_ensure_response($xml);
		//return $xml;//new WP_REST_Response( $xml, 200 );
	}
	function sdgc_newEvent($request){
	    global $wpdb;
        $table_name = $wpdb->prefix . "sdgc_events";
	    $params = $request->get_params();
	    $json = "{";
        $wpdb->insert($table_name, array(
            'summary' => $params["summary"],
            'description' => isset($params["description"]) ? $params["description"] : "",
            'startdate' => isset($params["startdate"]) ? $params["startdate"] : date_format(new DateTime(),"Y-m-d"),
            'starttime' => isset($params["starttime"]) ? $params["starttime"].":00" : "00:00:00",
            'enddate' => isset($params["enddate"]) && !strcmp($params["enddate"],"0000-00-00") ? $params["enddate"] : date_format(new DateTime(),"Y-m-d"),
            'endtime' => isset($params["endtime"]) ? $params["endtime"].":00" : "23:59:59",
            'location' => isset($params["location"]) ? $params["location"] : "",
            'map' => isset($params["mapurl"]) ? $params["mapurl"] : "",
            'postid' => isset($params["calendarid"]) ?$params["calendarid"] : -1,
            'customentry' => isset($params["customentry"]) ? $params["customentry"] : 1
        ));
//	    foreach($params as $key => $val){
//	        $json .= "'".$key."':'".$val."',";
//        }
        $json .= '"success" : true }';

        return new WP_REST_Response( $json, 200 );
    }

//	function sdgc_eventsJSONForPost($request){
//		global $wpdb;
//		$table_name = $wpdb->prefix . "sdgc_events";
//		$params = $request->get_params();
//
//		$results = $wpdb->get_results( $wpdb->prepare( "SELECT id,startdate,starttime,enddate,endtime,summary,description,location,map FROM {$table_name} where postid = %d", $params['id'] ), ARRAY_A );
//		$json = "{ 'monthly' : [";
//		foreach ($results as $res){
//			$evt = "{'id': ".$res["id"].",'name': '".$res["summary"]."', 'startdate': '".$res["startdate"]."', 'starttime': '".$res["starttime"]."', 'enddate': '".$res["enddate"]."', 'endtime': '".$res["endtime"]."' },";
//			$json .= $evt;
////      "color": "#FFB128",
////      "url": ""
//		}
//		$json .= "] }";
//		return new WP_REST_Response( $json, 200 );
//	}

//	function getCalendarPostAsJson($post){
//	  $calendarurl = GoogleCalendars::getCustomCalendarUrl($post->ID);
//	  $output = "";
//	  //echo($calendarurl);
//	  if(!empty($calendarurl)){
//	  	$html = GoogleCalendars::getCustomCalendarDom($calendarurl);
//			$days = array();
//			$i=0;
//			foreach($html->find('div.date-section') as $element){
//				$day = new stdClass();
//				$day->events = array();
//				$day->date = date_create_from_format('D M d, Y T',$element->find('div.date',0)->innertext . ' EST');
//				$j=0;
//				foreach($element->find('tr.event') as $event){
//				   $evt = new stdClass();
//				   $evt->time = (isset($event->find('div.tbg',0)->innertext) ? '' : $event->find('td.event-time',0)->innertext);
//				   $evt->title = $event->find('span.event-summary',0)->innertext;
//				   $evt->link = 'https://calendar.google.com/calendar/'.$event->find('a.event-link',0)->href;
//				   $day->events[$j] = $evt;
//				   $j++;
//				}
//				$days[$i] = $day;
//				$i++;
//			}
//
//			$output .= "{[";
//			foreach($days as $day){
//				$output .= "{'date':'".date_format($day->date, "Y-m-d")."',";
//				$output .= "'events':[";
//				foreach($day->events as $evt){
//					$output .= "{";
//					if(!empty($evt->time))
//						$output .= "'time':'".$evt->time."',";
//					$output .= "'title':'".$evt->title."',";
//					$output .= "'link':'".$evt->link."'";
//					$output .= "},";
//				}
//				$output = rtrim($output, ",");
//				$output .= "]},";
//			}
//			$output = rtrim($output, ",");
//			$output .= "]}";
//		  }
//	  return isset($output) ? $output : "";
//	}
}



add_action( 'wp_ajax_sdgc_eventsjson_post', 'sdgc_eventsjson_post' );
add_action( 'wp_ajax_nopriv_sdgc_eventsjson_post', 'sdgc_eventsjson_post' );
function  sdgc_eventsjson_post() {
	wp_send_json(sdgc_eventsListAsJson($_GET["id"]));
}

add_action( 'wp_ajax_sdgc_eventsxml_post', 'sdgc_eventsxml_post' );
add_action( 'wp_ajax_nopriv_sdgc_eventsxml_post', 'sdgc_eventsxml_post' );
function sdgc_eventsxml_post(){
    global $wpdb;
	$table_name = $wpdb->prefix . "sdgc_events";
	$post = $_GET["id"];

	$post_fields_urls = unserialize( get_post_meta($post, '_sdgc_calendar_urls', true) );
	$post_fields_color = unserialize( get_post_meta($post, '_sdgc_calendar_color', true) );

	$urlColorMap = [];
	foreach($post_fields_urls as $key => $url){
		$urlColorMap[$url] = $post_fields_color[$key];
	}

	$results = $wpdb->get_results( $wpdb->prepare( "SELECT id,calendar,startdate,starttime,enddate,endtime,summary,description,location,map FROM {$table_name} where postid = %d and (customentry = 0 or customentry = 2)", $post ), ARRAY_A );
	$xml = '<monthly>';
	foreach ($results as $res){
		$evt = '<event><id>'.$res["id"].'</id><name>'.htmlspecialchars($res["summary"], ENT_XML1, 'UTF-8').'</name><startdate>'.
		       $res["startdate"].'</startdate><starttime>'.substr($res["starttime"],0,5).'</starttime><enddate>'.
		       $res["enddate"].'</enddate><endtime>'.substr($res["endtime"],0,5).'</endtime>'.
		       '<color>'.(isset($urlColorMap[$res["calendar"]]) ? $urlColorMap[$res["calendar"]] : "#FFB128").'</color>'.
               '<description>'.htmlspecialchars($res["description"], ENT_XML1, 'UTF-8').'</description>'.
               '<location>'.htmlspecialchars($res["location"], ENT_XML1, 'UTF-8').'</location>'.
               '<map>'.htmlspecialchars($res["map"], ENT_XML1, 'UTF-8').'</map>'.
             '</event>';
		$xml .= $evt;
//      "color": "#FFB128",
//      "url": ""
	}
	$xml .= "</monthly>";
	print_r($xml);
	die();
}

function sdgc_eventsListAsJson($postid){
	global $wpdb;
	$table_name = $wpdb->prefix . "sdgc_events";

	$post_fields_urls = unserialize( get_post_meta($postid, '_sdgc_calendar_urls', true) );
	$post_fields_color = unserialize( get_post_meta($postid, '_sdgc_calendar_color', true) );

	$urlColorMap = [];
	foreach($post_fields_urls as $key => $url){
		$urlColorMap[$url] = $post_fields_color[$key];
	}

	$results = $wpdb->get_results( $wpdb->prepare( "SELECT id,calendar,startdate,starttime,enddate,endtime,summary,description,location,map FROM {$table_name} where postid = %d", $postid ), ARRAY_A );
	$evts = array();
	foreach ($results as $res){
		array_push($evts, array(
			"id" => $res["id"],
			"name" => htmlspecialchars($res["summary"], ENT_XML1, 'UTF-8'),
			"startdate" => $res["startdate"],
			"starttime" => substr($res["starttime"],0,5),
			"enddate" => $res["enddate"],
			"endtime" => substr($res["endtime"],0,5),
			"color" => isset($urlColorMap[$res["calendar"]]) ? $urlColorMap[$res["calendar"]] : "#FFB128",
            "description" => isset($res["description"]) ? htmlspecialchars($res["description"], ENT_XML1, 'UTF-8') : '',
            "location" => isset($res["location"]) ? htmlspecialchars($res["location"], ENT_XML1, 'UTF-8') : '',
            "map" => isset($res["map"]) ? htmlspecialchars($res["map"], ENT_XML1, 'UTF-8') : ''
		));
//      "url": ""
	}
	return array('monthly' => $evts) ;
}

add_action( 'init', 'sdgc_init_internal' );
function sdgc_init_internal() {
	add_rewrite_rule( 'sdgc_new_event.php$', 'index.php?sdgc_new_event=1', 'top' );
	defaultCalendarEntryForm();
}

add_filter( 'query_vars', 'sdgc_query_vars' );
function sdgc_query_vars( $query_vars ) {
	$query_vars[] = 'sdgc_new_event';
	return $query_vars;
}

add_action( 'parse_request', 'sdgc_parse_request' );
function sdgc_parse_request( &$wp ) {
	if ( array_key_exists( 'sdgc_new_event', $wp->query_vars ) ) {
		include 'sdgc_new_event.php';
		exit();
	}
	return;
}

function defaultCalendarEntryForm() {
	$TemplateFileSourceURL = SDGC_PLUGIN_DIR . '/sd-frontend-entry.php'; // Address to your file in the plugin directory
	$TemplateFileTargetURL = get_stylesheet_directory() . '/page-calendar-entry.php'; // Note the "page-" prefix, it is necessary for WP to select this file instead of the general "page.php". The name after the prefix must match the slug of the page created in WP.
    if ( !file_exists( $TemplateFileSourceURL ) ) {
		return FALSE;
	}
	$GetTemplate = file_get_contents( $TemplateFileSourceURL );
	if ( !$GetTemplate ) {
		return FALSE;
	}
	$WriteTemplate = file_put_contents( $TemplateFileTargetURL, $GetTemplate );
	if ( !$WriteTemplate ) {
		return FALSE;
	}
	return TRUE;
}

?>