<script src="https://maps.googleapis.com/maps/api/js?key=<?php echo get_option('sdgc_googlekey_option'); ?>&libraries=places&callback=initAutocomplete" async defer></script>
<script>
    Date.prototype.toDateInputValue = (function() {
        var local = new Date(this);
        local.setMinutes(this.getMinutes() - this.getTimezoneOffset());
        return local.toJSON().slice(0,10);
    });
    jQuery( window ).on( "load", function() {
        jQuery('#startdate').val(new Date().toDateInputValue());
        jQuery('#enddate').val(new Date().toDateInputValue());
    });
    var autocomplete, map;
    function initAutocomplete() {
        autocomplete = new google.maps.places.Autocomplete(
            /** @type {!HTMLInputElement} */(document.getElementById('location')),
            {types: ['geocode']});
        map = new google.maps.Map(/** @type {!HTMLInputElement} */document.getElementById('map'), {center: {lat: 33.520019, lng: -82.105344}, zoom: 13});
        autocomplete.bindTo('bounds', map);
        var geocoder = new google.maps.Geocoder;
        var marker = new google.maps.Marker({ map: map });
        autocomplete.addListener('place_changed', function() {
            var place = autocomplete.getPlace();
            if (!place.place_id) {
                return;
            }
            jQuery("#mapurl").val(place.url);
            geocoder.geocode({'placeId': place.place_id}, function(results, status) {
                if (status !== 'OK') {
                    window.alert('Geocoder failed due to: ' + status);
                    return;
                }
                map.setZoom(11);
                map.setCenter(results[0].geometry.location);
                marker.setPlace({
                    placeId: place.place_id,
                    location: results[0].geometry.location
                });
                marker.setVisible(true);
            });
        });
    }
    function geolocate() {
        if (navigator.geolocation) {
            navigator.geolocation.getCurrentPosition(function(position) {
                var geolocation = {
                    lat: position.coords.latitude,
                    lng: position.coords.longitude
                };
                var circle = new google.maps.Circle({
                    center: geolocation,
                    radius: position.coords.accuracy
                });
                autocomplete.setBounds(circle.getBounds());
            });
        }
    }
</script>
<link rel="stylesheet" id="monthly-css" href="<?php echo SDGC_URL; ?>/css/entryform.css" type="text/css" media="all">
<?php if(isset($newentrypassed) && $newentrypassed){ ?>
	<div class="alert alert-success" role="alert">
		<strong>Event added!</strong> You successfully added an event and it is awaiting approval.
	</div>
<?php } ?>
<div class="container">
	<div id="new_event_error"></div>
	<form method="post" id="new_event_form" onsubmit="event.preventDefault(); validateNewEventForm();">
		<div class="row">
			<div class="col-md-6">
				<label for="summary">Summary/Title</label>
				<input type="text" name="summary" id="summary" size="50" required/>
			</div>
		</div>
		<div class="row">
			<div class="col-md-6">
				<label for="description">Description</label>
				<textarea name="description" id="description" required rows="5" cols="50"></textarea>
			</div>
		</div>
		<div class="row">
			<div class="col-md-3 datecol">
				<label for="startdate">Start Date</label>
				<input type="date" name="startdate" id="startdate" required/>
			</div>
			<div class="col-md-3 timecol">
				<label for="starttime">Start Time</label>
				<input type="time" name="starttime" id="starttime"/>
			</div>
		</div>
		<div class="row">
			<div class="col-md-3 datecol">
				<label for="enddate">End Date</label>
				<input type="date" name="enddate" id="enddate"/>
			</div>
			<div class="col-md-3 timecol">
				<label for="endtime">End Time</label>
				<input type="time" name="endtime" id="endtime"/>
			</div>
		</div>
		<div class="row">
			<div class="col-md-6">
				<label for="location">Location</label>
				<input type="text" name="location" id="location" placeholder="Enter your address" size="50"
				       onFocus="geolocate()"/>
			</div>
		</div>
		<div class="row paddingtop15">
			<div class="col-md-6 btn-group">
				<button class="btn btn-block btn-primary">SUBMIT</button>
			</div>
		</div>
		<div class="row">
			<div class="col-md-6">
				<input type="hidden" name="mapurl" id="mapurl"/>
				<div id="map"></div>
			</div>
		</div>
	</form>
</div>